/*-----------------------------------------------------
    NewsLister admin.js 
	
    @package NewsLister
	@since 1.0
	
	@version    1.0.0
	@copyright Tenderfeel
	@author Tenderfeel(tenderfeel@gmail.com)
	@link http://tenderfeel.xsrv.jp/ 
------------------------------------------------------*/

var NLConfig = new Hash({
		logareaID:"logarea",//ログ表示要素のID
		messageID:"message",//メッセージ要素のID
		postfile:'include/post.php',//post.phpまでのパス
		loadMethod:'get',//ログ読み込み時のメソッド
		logmax:10 //ログの最大表示数
	
	});

/*----------------------------------------------------*/

window.addEvent('domready', function(){
									 
	
	//ログ表示要素
	var logarea = $(NLConfig.logareaID);
	
	//メッセージ要素
	var message = $(NLConfig.messageID);
	var messageEff = new Fx.Morph(message);
	messageEff.set({'opacity': 0});
	
	//削除ボタン
	var del = new Element("span",{ html:"[x]","class":"del"});
	
	//ローディングバー
	var loader = new Element("p",{
				 id:"loader",
				 html:'<img src="include/images/loader.gif" width="128" height="15" alt="Loading" />',
				 "morph":{duration: 500}
			});
	
	
	loader.inject(logarea,"before");
	
	//保存/////////////////////////////////////////	
	$("save").addEvent("click",function(e){
		e.stop();
		
		var year = $("year"); //年
		var month = $("month"); //月
		var day = $("day"); //日
		var hour = $("hour"); //時
		var minit = $("min"); //分
		var comment = $("comment");//本文
		
		var dataSave = new Request.JSON({
			url:NLConfig.postfile,
			method: 'post',
			data:{"mode":"save",
					"year":year.value,
					"month":month.getSelected()[0].value,
					"day":day.value,
					"hour":hour.value,
					"min":minit.value,
					"comment":comment.value
			},
			onRequest: function(){
				var dd = new Date();
				hour.value = dd.getHours();
				minit.value = dd.getMinutes();
				comment.value = "";
			},
			onSuccess: function(txt) {
				
				//削除ボタン
			 	var copy = del.clone();
			 	copy.addEvent("click",function(){
							var self = this.getParent();
							var myEffect = new Fx.Morph(self,{onComplete:function(){self.destroy();}});
							 myEffect.start({
								'margin': 0,
								'padding': 0,
								'height': 0,
								'opacity': 0
							});
							 //削除リクエスト送信を仕込んどく
							 deleteRequest.send({data:{"mode":"delete","index":txt.id}});	  
						});
				
				
				//送信した内容の段落作成
			  	var parag = new Element("p",{html:"<span class=\"date\">"+showLocalDate(txt.date)+"</span><strong>"+txt.comment+"</strong>"}).grab(copy,"top").fade("hide").inject($("p1"),"top");
				
				parag.fade("in");
				
				console.log($("p1").getChildren().length > NLConfig.logmax);
				
			},
			onFailure: function() {
			   error_disp("保存時にエラーが発生しました");
			}
		  })
	
		if(comment.value!=""){
			dataSave.send();
			message.set("html","保存しました");
			messageEff.start({'opacity': 1,"height":30});
			message_hide.delay(3000);
		}else{
			message.set("html","コメントを入力してください");
			messageEff.start({'opacity': 1,"height":30});
			message_hide.delay(3000);
		}
		
	});
	
	//ログの表示////////////////////////////////////
	var loading = new Request.JSONP({
		url:NLConfig.postfile,
		method:NLConfig.loadMethod,
		data:{"mode":"load"},
		onRequest: function(){
			loader.morph({'height':15, 'opacity': 1, 'padding': 20});
		},
		onSuccess: function(txt) {
			
			//ページ番号をlogareaから引き出す
			if(logarea.retrieve("page"))
				var page = logarea.retrieve("page");
			else
				var page = 1;
			
			if(txt.items.length >= 1){
				loader.morph({'height':0, 'opacity': 0, 'padding': 0});//ローディングバー非表示
				
				var section;
				
				txt.items.each(function(item,i){
					
					if((i % NLConfig.logmax)==0){
						section = new Element("div",{"class":"section","id":"p"+ page});//ページ
						if(page!=1){
							section.setStyle("display","none");
						}
						page++;
						//ページ番号保存
						logarea.store("page",page);
					}
					
					//削除ボタン
					var copy = del.clone();
					copy.addEvent("click",function(){
								var self = this.getParent();
								var myEffect = new Fx.Morph(self,{onComplete:function(){self.destroy();
								
								if($("p"+(logarea.retrieve("page")-1)).getChildren().length == 0)
									logreset();}});
								
								 myEffect.start({
									'margin': 0,
									'padding': 0,
									'height': 0,
									'opacity': 0
								});
								 deleteRequest.send({data:{"mode":"delete","index":item.id}});	  
							});
					
						//段落作成
						new Element("p",{html:"<span class=\"date\">"+showLocalDate(item.date)+"</span><strong>"+item.comment+"</strong>"}).grab(copy,"top").inject(section);
						
						section.inject(logarea);
					});
				
				
					//ページナビ///////////////////////////////////
					var pageNavi = new Element("p",{id:"pageNavi",text:"Page:"});
					for(i=1; i < page ; i++){
						new Element("a",{text:i, href:"#", class:"p" + i,
									events:{ 
										click:function(e){
											e.stop();
											logarea.getChildren().setStyle("display","none");
											pageNavi.getChildren().setStyle("background-color","#fff");
											$(this.className).setStyle("display","block");
											this.setStyle("background-color","yellow");
										}
									} 
								}).inject(pageNavi);
						if((i % 20)==0) {
							new Element("br").inject(pageNavi);
						}
					}
					pageNavi.inject(logarea,"before");
				
				}else{
					console.log("text");
					new Element("div",{"class":"section","id":"p"+page}).inject(logarea);//ページ
					logarea.store("page",page);
					loader.morph({'height':0, 'opacity': 0,  'padding': 0});
					
				}
		},
		onFailure: function() {
			error_disp("読み込み時にエラーが発生しました");
		}
	});
	
	loading.send();
	
	//リロード/////////////////////////////////////
	
	$("reload").addEvent("click",function(){
			logreset();
	});
	
	//削除/////////////////////////////////////////
	var deleteRequest = new Request({
							url:"include/post.php",
							method: 'post',
							onSuccess: function(txt) {
								message.set("html",txt);
								messageEff.start({'opacity': 1,"height":30});
								message_hide.delay(3000);
							},
							onFailure: function() {
							  error_disp("削除時にエラーが発生しました");
							}
						});
	
	var logreset = function(){
		
		//ページ番号保存
		logarea.store("page",1);
		$("pageNavi").destroy();
		logarea.getChildren().each(function(item){
			item.fade("out");
			item.destroy();
		});
		loading.send();
	}
	//メッセージを隠す/////////////////////////////
	var message_hide = function(){
			messageEff.start({
				'height': 0,
				'opacity': 0,
				onComplete:function(){message.empty();}
			});
	}
	//エラー表示///////////////////////////////////
	var error_disp = function (txt){
		 message.set("html",txt);
		 messageEff.start({'opacity': 1,"height":30});
	}

});

function showLocalDate(timestamp)
{
  var dt = new Date(timestamp * 1000);
  return dt.getFullYear()+"/"+(dt.getMonth()+1)+"/"+dt.getDate()+" @"+dt.getHours()+":"+dt.getMinutes();
} 